Imports Excel
Imports Microsoft

' This project needs a reference to the Excel object library.
' Select Project\Add Reference, click on the COM tab, and select:
'       Microsoft Excel 11.0 Object Library

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents txtDatabase As System.Windows.Forms.TextBox
    Friend WithEvents btnAnalyze As System.Windows.Forms.Button
    Friend WithEvents DBConn As System.Data.OleDb.OleDbConnection
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label
        Me.txtDatabase = New System.Windows.Forms.TextBox
        Me.btnAnalyze = New System.Windows.Forms.Button
        Me.DBConn = New System.Data.OleDb.OleDbConnection
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(8, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(48, 16)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Database"
        '
        'txtDatabase
        '
        Me.txtDatabase.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtDatabase.Location = New System.Drawing.Point(64, 8)
        Me.txtDatabase.Name = "txtDatabase"
        Me.txtDatabase.Size = New System.Drawing.Size(556, 20)
        Me.txtDatabase.TabIndex = 1
        Me.txtDatabase.Text = ""
        '
        'btnAnalyze
        '
        Me.btnAnalyze.Anchor = System.Windows.Forms.AnchorStyles.Top
        Me.btnAnalyze.Location = New System.Drawing.Point(278, 40)
        Me.btnAnalyze.Name = "btnAnalyze"
        Me.btnAnalyze.Size = New System.Drawing.Size(64, 24)
        Me.btnAnalyze.TabIndex = 2
        Me.btnAnalyze.Text = "Analyze"
        '
        'Form1
        '
        Me.AcceptButton = Me.btnAnalyze
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(624, 77)
        Me.Controls.Add(Me.btnAnalyze)
        Me.Controls.Add(Me.txtDatabase)
        Me.Controls.Add(Me.Label1)
        Me.Name = "Form1"
        Me.Text = "Form1"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim txt As String

        txt = System.Windows.Forms.Application.StartupPath
        txt = txt.Substring(0, txt.LastIndexOf("\"))
        txtDatabase.Text = txt & "\TestData.mdb"
        txtDatabase.Select(0, 0)
    End Sub

    Private Sub btnAnalyze_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAnalyze.Click
        Me.Cursor = Cursors.WaitCursor
        System.Windows.Forms.Application.DoEvents()

        ' Open Excel and create a new workbook.
        Dim excel_app As New Excel.Application
        excel_app.Visible = True
        Dim excel_workbook As Excel.Workbook = _
            excel_app.Workbooks.Add()
        Dim excel_worksheet As Excel.Worksheet = _
            DirectCast(excel_workbook.Sheets(1), Excel.Worksheet)
        excel_worksheet.Range("A1", "Z1").Columns.ColumnWidth = 20

        ' Examine the tables.
        Dim row_num As Integer = 1

        ' Section heading.
        excel_worksheet.Cells(row_num, 1) = "Tables"
        With excel_worksheet.Range("A" & row_num).Font
            .Size = 25
            .Bold = True
            .Color = RGB(255, 0, 0)
        End With
        row_num += 1

        ' Open the database connection.
        DBConn.ConnectionString = _
            "Provider=""Microsoft.Jet.OLEDB.4.0"";" & _
            "Data Source=""" & txtDatabase.Text & """;" & _
            "Mode=Share Deny None;" & _
            "persist security info=False;"
        DBConn.Open()

        ' Get schema information for TABLE type tables only.
        ' This excludes access and system tables.
        Dim dt_table As System.Data.DataTable = _
            DBConn.GetOleDbSchemaTable( _
                OleDb.OleDbSchemaGuid.Tables, _
                New Object() {Nothing, Nothing, Nothing, "TABLE"})

        ' Loop over the tables.
        For Each dr_table As DataRow In dt_table.Rows
            ' Display the table's name in the form's title bar.
            Dim table_name As String = dr_table("TABLE_NAME").ToString
            Me.Text = "MDBAnalyzer: " & table_name
            System.Windows.Forms.Application.DoEvents()

            ' Display the table's name, description, date created, and date modified.
            excel_worksheet.Cells(row_num, 1) = table_name
            With excel_worksheet.Range("A" & row_num).Font
                .Size = 20
                .Bold = True
                .Color = RGB(0, 0, 255)
            End With
            row_num += 1

            If dr_table.IsNull("DESCRIPTION") Then
                excel_worksheet.Cells(row_num, 1) = "<no description>"
            Else
                excel_worksheet.Cells(row_num, 1) = dr_table("DESCRIPTION").ToString
            End If
            row_num += 1
            excel_worksheet.Cells(row_num, 1) = "Created:"
            excel_worksheet.Cells(row_num, 2) = dr_table("DATE_CREATED").ToString
            row_num += 1
            excel_worksheet.Cells(row_num, 1) = "Modified:"
            excel_worksheet.Cells(row_num, 2) = dr_table("DATE_MODIFIED").ToString
            row_num += 1

            ' Subsection header.
            excel_worksheet.Cells(row_num, 1) = "Fields"
            With excel_worksheet.Range("A" & row_num).Font
                .Size = 16
                .Bold = True
                .Color = RGB(0, 128, 255)
            End With
            row_num += 1

            ' Get the table's field data.
            Dim dt_field As System.Data.DataTable = _
                DBConn.GetOleDbSchemaTable( _
                    OleDb.OleDbSchemaGuid.Columns, _
                    New Object() {Nothing, Nothing, table_name})

            ' Headers.
            Dim field_properties() As String = Split("Name,Type,Char Length,Is Nullable,DefaultValue,Description", ",")
            For col_num As Integer = 0 To field_properties.Length - 1
                excel_worksheet.Cells(row_num, col_num + 1) = field_properties(col_num)
            Next col_num
            With excel_worksheet.Range("A" & row_num, "Z" & row_num).Font
                .Bold = True
            End With
            row_num += 1

            ' Display the table's field's information.
            For Each dr_field As DataRow In dt_field.Rows
                ' Name.
                excel_worksheet.Cells(row_num, 1) = dr_field("COLUMN_NAME").ToString

                ' Type.
                Dim ole_db_type As OleDb.OleDbType = _
                    CType(dr_field("DATA_TYPE"), OleDb.OleDbType)
                excel_worksheet.Cells(row_num, 2) = ole_db_type.ToString

                excel_worksheet.Cells(row_num, 3) = dr_field("CHARACTER_MAXIMUM_LENGTH").ToString
                excel_worksheet.Cells(row_num, 4) = dr_field("IS_NULLABLE").ToString

                If CBool(dr_field("COLUMN_HASDEFAULT").ToString) Then _
                    excel_worksheet.Cells(row_num, 5) = dr_field("COLUMN_DEFAULT").ToString

                If Not dr_field.IsNull("DESCRIPTION") Then
                    excel_worksheet.Cells(row_num, 6) = dr_field("DESCRIPTION").ToString
                End If

                row_num += 1
            Next dr_field

            ' Subsection header.
            excel_worksheet.Cells(row_num, 1) = "Indexes"
            With excel_worksheet.Range("A" & row_num).Font
                .Size = 16
                .Bold = True
                .Color = RGB(0, 128, 255)
            End With
            row_num += 1

            ' Get the table's index data.
            Dim dt_index As System.Data.DataTable = _
                DBConn.GetOleDbSchemaTable( _
                    OleDb.OleDbSchemaGuid.Indexes, _
                    New Object() {Nothing, Nothing, Nothing, Nothing, table_name})

            ' Headers.
            Dim index_properties() As String = Split("Name,Primary,Unique,Column", ",")
            For col_num As Integer = 0 To index_properties.Length - 1
                excel_worksheet.Cells(row_num, col_num + 1) = index_properties(col_num)
            Next col_num
            With excel_worksheet.Range("A" & row_num, "Z" & row_num).Font
                .Bold = True
            End With
            row_num += 1

            ' Display the table's index's information.
            For Each dr_index As DataRow In dt_index.Rows
                excel_worksheet.Cells(row_num, 1) = dr_index("INDEX_NAME").ToString
                excel_worksheet.Cells(row_num, 2) = dr_index("PRIMARY_KEY").ToString
                excel_worksheet.Cells(row_num, 3) = dr_index("UNIQUE").ToString
                excel_worksheet.Cells(row_num, 4) = dr_index("COLUMN_NAME").ToString
                row_num += 1
            Next dr_index
        Next dr_table

        ' Foreign keys.
        ' Section heading.
        excel_worksheet.Cells(row_num, 1) = "Foreign Keys"
        With excel_worksheet.Range("A" & row_num).Font
            .Size = 25
            .Bold = True
            .Color = RGB(255, 0, 0)
        End With
        row_num += 1

        ' Foreign keys.
        Dim dt_fkeys As System.Data.DataTable = _
            DBConn.GetOleDbSchemaTable( _
                OleDb.OleDbSchemaGuid.Foreign_Keys, Nothing)

        ' Headers.
        Dim fkeys_properties() As String = Split("Primary Column,Foreign Column,Primary Key,Foreign Key,Update Rule,Delete Rule", ",")
        For col_num As Integer = 0 To fkeys_properties.Length - 1
            excel_worksheet.Cells(row_num, col_num + 1) = fkeys_properties(col_num)
        Next col_num
        With excel_worksheet.Range("A" & row_num, "Z" & row_num).Font
            .Bold = True
        End With
        row_num += 1

        ' Display foreign key data.
        For Each dr_fkeys As DataRow In dt_fkeys.Rows
            excel_worksheet.Cells(row_num, 1) = _
                dr_fkeys("PK_TABLE_NAME").ToString & "." & _
                dr_fkeys("PK_COLUMN_NAME").ToString
            excel_worksheet.Cells(row_num, 2) = _
                dr_fkeys("FK_TABLE_NAME").ToString & "." & _
                dr_fkeys("FK_COLUMN_NAME").ToString
            excel_worksheet.Cells(row_num, 3) = dr_fkeys("PK_NAME").ToString
            excel_worksheet.Cells(row_num, 4) = dr_fkeys("FK_NAME").ToString
            excel_worksheet.Cells(row_num, 5) = dr_fkeys("UPDATE_RULE").ToString
            excel_worksheet.Cells(row_num, 6) = dr_fkeys("DELETE_RULE").ToString
            row_num += 1
        Next dr_fkeys

        excel_worksheet = Nothing
        excel_workbook = Nothing
        excel_app = Nothing
        DBConn.Close()

        Me.Text = "Done"
        Me.Cursor = Cursors.Default
        MessageBox.Show("Done", "Done", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub
End Class
